﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication18
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("Child");
            EnumVisual(TestButton);
            System.Diagnostics.Debug.WriteLine("Parent");
            EnumVisualforParent(TestButton);
        }

        static public void EnumVisual(Visual myVisual)
        {
            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(myVisual); i++)
            {
                Visual childVisual = (Visual)VisualTreeHelper.GetChild(myVisual, i);
                System.Diagnostics.Debug.WriteLine(childVisual.GetType());
                EnumVisual(childVisual);
            }
        }

        static public void EnumVisualforParent(DependencyObject myVisual)
        {
            var parentVisual = VisualTreeHelper.GetParent(myVisual);
            if (parentVisual != null)
            {
                System.Diagnostics.Debug.WriteLine(parentVisual.GetType());
                EnumVisualforParent(parentVisual);
            }
        }

        private void XamPropertyGrid_MouseDown(object sender, MouseButtonEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("Parent MouseDown");
            EnumVisualforParent(TestButton);
        }
    }
}
